//#########################################################################
// File: MYDEFS.H
//
//
//#########################################################################
// Last change: 25.07.2005
//#########################################################################
// Compiler: AVR-GCC 3.4.3
//#########################################################################

#ifndef __MYDEFS_H
#define __MYDEFS_H

//#define F_8   
//#define F_11059
#define F_16

#ifdef F_8
 #define F_CPU      8000000    //processor clock
#endif

#ifdef F_16
 #define F_CPU      16000000    //processor clock
#endif

#ifdef F_11059
 #define F_CPU      11059200    //processor clock
#endif

#define UART_BAUD_RATE	9600

#define MMC_DEBUG_IDENTIFY
#define MMC_DEBUG_SECTORS
#define MMC_DEBUG_COMMANDS

#define T1_PRESCALER	8
#define T1_TICKS   	F_CPU / ( T1_PRESCALER * 65536 )	
#define T1_ONESECOND    T1_TICKS

#define NOP() asm volatile ("nop" ::)
//WinAVR 3.4.3 setzt die Bitsetzbefehle sbi(),cbi() ins Assembler-Listing fr diese
//beiden #defines ein ! Also kein Grund Inline Assembler zu benutzen.
#define sbi(portn, bitn) ((portn)|=(1<<(bitn)))
#define cbi(portn, bitn) ((portn)&=~(1<<(bitn)))
//#define sbi(portn, bitn) asm volatile("sbi %0, %1" : : "I" (_SFR_IO_ADDR(portn)), "I" ((uint8_t)(bitn)))
//#define cbi(portn, bitn) asm volatile("cbi %0, %1" : : "I" (_SFR_IO_ADDR(portn)), "I" ((uint8_t)(bitn)))


#if defined (__AVR_ATmega32__) || defined (__AVR_ATmega323__) || defined (__AVR_ATmega16__)
 #define RED_BIT	7	//Pin number for red LED
 #define RED_PORT 	PORTD   //Port where red LED is located
 #define RED_DDR 	DDRD    //Port direction register where red LED is located
 #define GREEN_BIT	6	//Pin number for green LED
 #define GREEN_PORT 	PORTD   //Port where green LED is located
 #define GREEN_DDR 	DDRD    //Port direction register where green LED is located
#elif defined (__AVR_ATmega128__) || defined (__AVR_ATmega64__)
 #define RED_BIT	7	//Pin number for red LED
 #define RED_PORT 	PORTE   //Port where red LED is located
 #define RED_DDR 	DDRE    //Port direction register where red LED is located
 #define GREEN_BIT	6	//Pin number for green LED
 #define GREEN_PORT 	PORTE   //Port where green LED is located
 #define GREEN_DDR 	DDRE    //Port direction register where green LED is located
#elif defined (__AVR_ATmega168__) || defined (__AVR_ATmega8__) || defined (__AVR_ATmega88__)
 #define RED_BIT	5	//Pin number for red LED
 #define RED_PORT 	PORTD   //Port where red LED is located
 #define RED_DDR 	DDRD    //Port direction register where red LED is located
 #define GREEN_BIT	4	//Pin number for green LED
 #define GREEN_PORT 	PORTD   //Port where green LED is located
 #define GREEN_DDR 	DDRD    //Port direction register where green LED is located
#else
#  error "processor type not defined in mydefs.h"
#endif



//Die beiden LED's
#define RED_ON() { sbi(RED_DDR,RED_BIT); cbi(RED_PORT,RED_BIT); }
#define RED_OFF() { sbi(RED_DDR,RED_BIT); sbi(RED_PORT,RED_BIT); }

#define GREEN_ON() { sbi(GREEN_DDR,GREEN_BIT); cbi(GREEN_PORT,GREEN_BIT); }
#define GREEN_OFF() { sbi(GREEN_DDR,GREEN_BIT); sbi(GREEN_PORT,GREEN_BIT); }


//#define MODE	bit_is_set(PINA,PA0)

#endif //__MYDEFS_H
